SystemOrganization addCategory: #ProyectoFinal!

Object subclass: #Issuer
	instanceVariableNames: 'name lastName address DNI CUIT'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

!Issuer class methodsFor: 'class initialization' stamp: 'PauloPerez 7/16/2012 20:25'!
name: aName lastName: aLastName DNI: aDNI CUIT: aCUIT address: anAddress
	^ (self new)
		name: aName
			lastName: aLastName
			DNI: aDNI
			CUIT: aCUIT
			address: anAddress;
		yourself! !

!Issuer methodsFor: 'accessing' stamp: 'PauloPerez 7/16/2012 20:24'!
name: aName lastName: aLastName DNI: aDNI CUIT: aCUIT address: anAddress
	name := aName.
	lastName := aLastName.
	DNI := aDNI.
	CUIT := aCUIT.
	address := anAddress! !

Object subclass: #Order
	instanceVariableNames: 'quantity price date issuer unitPrice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

!Order class methodsFor: 'class initialization' stamp: 'PauloPerez 7/16/2012 19:01'!
ask: quantity price: amount
	^ SalesOrder ask: quantity price: amount! !

!Order class methodsFor: 'class initialization' stamp: 'PauloPerez 7/16/2012 19:01'!
bid: quantity price: amount
	^ PurchaseOrder bid: quantity price: amount! !

!Order methodsFor: 'comparing' stamp: 'PauloPerez 7/17/2012 14:03'!
<= anOrder
	^ unitPrice <= anOrder unitPrice! !

!Order methodsFor: 'comparing' stamp: 'PauloPerez 7/17/2012 14:59'!
>= anOrder
	^ unitPrice >= anOrder unitPrice! !

!Order methodsFor: 'private' stamp: 'PauloPerez 7/18/2012 01:39'!
computeUnitPrice
	unitPrice := (price / quantity) asFloat! !

!Order methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 7/17/2012 16:28'!
date
	^ date! !

!Order methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 7/18/2012 13:32'!
price
	^ price! !

!Order methodsFor: 'printing' stamp: 'PauloPerez 7/17/2012 13:40'!
printOn: aStream
	aStream
		nextPutAll: 'Unit Price ';
		print: unitPrice;
		space;
		space;
		nextPutAll: 'Quantity: ';
		print: quantity;
		space;
		space;
		nextPutAll: 'Price: ';
		print: price;
		cr! !

!Order methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 7/17/2012 14:59'!
quantity
	"Retorna la cantidad de elementos solicitados u ofertados en una orden"

	^ quantity! !

!Order methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 7/18/2012 15:37'!
quantity: aQuantity price: amount
	quantity := aQuantity.
	price  := amount.
	self computeUnitPrice
	! !

!Order methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 7/17/2012 20:35'!
quantity: aQuantity price: amount date: aDate issuer: anIssuer 
	self quantity: aQuantity price: amount.
	date := aDate.
	issuer := anIssuer! !

!Order methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 7/18/2012 15:35'!
quantity: aQuantity unitPrice: amount
	quantity := aQuantity.
	unitPrice := amount.
	! !

!Order methodsFor: 'accessing' stamp: 'PauloPerez 7/17/2012 13:07'!
unitPrice
	^ unitPrice! !

Order subclass: #PurchaseOrder
	instanceVariableNames: 'receivingAddress shippingMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

!PurchaseOrder class methodsFor: 'class initialization' stamp: 'PauloPerez 7/13/2012 18:46'!
ask: quantity price: amount
	^ self shouldNotImplement! !

!PurchaseOrder class methodsFor: 'class initialization' stamp: 'DiegoValdeblanquez 7/18/2012 15:36'!
bid: quantity price: amount
	^ (self new)
		quantity: quantity unitPrice: amount;
		yourself! !

!PurchaseOrder class methodsFor: 'class initialization' stamp: 'DiegoValdeblanquez 7/17/2012 20:34'!
bid: quantity price: amount date: aDate issuer: anIssuer receivingAddress: aReceivingAddress shippingMethod: aShippingMethod
	^ (self new)
		bid: quantity
			price: amount
			date: aDate
			issuer: anIssuer
			receivingAddress: aReceivingAddress
			shippingMethod: aShippingMethod;
		yourself! !

!PurchaseOrder methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 7/17/2012 20:36'!
bid: aQuantity price: amount date: aDate issuer: anIssuer  receivingAddress: aReceivingAddress shippingMethod: aShippingMethod 
	self
		quantity: aQuantity
		price: amount
		date: aDate
		issuer: anIssuer.
	receivingAddress := aReceivingAddress.
	shippingMethod := aShippingMethod! !

!PurchaseOrder methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 7/18/2012 16:38'!
printOn: aStream
	aStream
		nextPutAll: 'Orden de compra ';
		cr;
		nextPutAll: 'Con precio unitario: ';
		print: self unitPrice ;
		cr;
		nextPutAll: 'Con cantidad de unidades a comprar: ';
		print: self quantity;
		cr;
		nextPutAll: 'Con fecha de ingreso: ';
		print: self date;
		cr.
	aStream cr! !

Order subclass: #SalesOrder
	instanceVariableNames: 'paymentMethod availabilityDate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

!SalesOrder class methodsFor: 'class initialization' stamp: 'DiegoValdeblanquez 7/18/2012 15:36'!
ask: quantity price: amount
	^ (self new)
		quantity: quantity  unitPrice: amount;
		yourself! !

!SalesOrder class methodsFor: 'class initialization' stamp: 'PauloPerez 7/16/2012 20:52'!
ask: quantity price: amount date: aDate issuer: anIssuer paymentMethod: aPaymentMethod availabilityDate: anAvailabilityDate
	^ (self new)
		ask: quantity
			price: amount
			date: aDate
			issuer: anIssuer
			paymentMethod: aPaymentMethod
			availabilityDate: anAvailabilityDate;
		yourself! !

!SalesOrder class methodsFor: 'class initialization' stamp: 'PauloPerez 7/13/2012 18:47'!
bid: quantity price: amount
	^ self shouldNotImplement! !

!SalesOrder methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 7/17/2012 20:36'!
ask: aQuantity price: amount date: aDate issuer: anIssuer  paymentMethod: aPaymentMethod availabilityDate: anAvailabilityDate
	self
		quantity: aQuantity
		price: amount
		date: aDate
		issuer: anIssuer.
	paymentMethod := aPaymentMethod.
	availabilityDate := anAvailabilityDate! !

!SalesOrder methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 7/18/2012 16:38'!
printOn: aStream
	aStream
		nextPutAll: 'Orden de venta ';
		cr;
		nextPutAll: 'Con precio unitario: ';
		print: self unitPrice ;
		cr;
		nextPutAll: 'Con cantidad de unidades a vender ';
		print: self quantity;
		cr;
		nextPutAll: 'Con fecha de ingreso: ';
		print: self date;
		cr.
	aStream cr! !

Object subclass: #OrderBook
	instanceVariableNames: 'purchaseOrders salesOrders marketPrice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

!OrderBook methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 20:56'!
addOrder: anOrder
	"Agrega una orden al arreglo de ordenes dependiendo de su tipo"

	(anOrder isMemberOf: PurchaseOrder)
		ifTrue: [ purchaseOrders add: anOrder ].
	(anOrder isMemberOf: SalesOrder)
		ifTrue: [ salesOrders add: anOrder ]! !

!OrderBook methodsFor: 'initialize-release' stamp: 'PauloPerez 7/17/2012 13:39'!
initialize
	purchaseOrders := OrderedCollection new.
	salesOrders := OrderedCollection new! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/17/2012 22:18'!
marketPrice
	"El Precio de Mercado es el precio nico por unidad al cual se comercializarn el producto en la etapa de Trading"

	| demand supply theoreticalTrade |
	theoreticalTrade := TheoreticalTrade new.
	purchaseOrders
		do: [ :purchaseOrder | 
			demand := 0.
			(purchaseOrders select: [ :theEqualOrGreaterPurchaseOrder | purchaseOrder <= theEqualOrGreaterPurchaseOrder ])
				do: [ :equalOrGreaterPurchaseOrder | demand := demand + equalOrGreaterPurchaseOrder quantity ].
			theoreticalTrade addUnit: purchaseOrder unitPrice demand: demand ].
	salesOrders
		do: [ :salesOrder | 
			supply := 0.
			(salesOrders select: [ :theEqualOrLessSalesOrder | theEqualOrLessSalesOrder <= salesOrder ])
				do: [ :equalOrLessSalesOrder | supply := supply + equalOrLessSalesOrder quantity ].
			theoreticalTrade addUnit: salesOrder unitPrice supply: supply ].
	marketPrice := theoreticalTrade priceForMaximumTheoreticalAmount.
	^ marketPrice! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'OLSA 7/17/2012 13:08'!
totalOrders
	"comment stating purpose of message"

	^ purchaseOrders  size + salesOrders  size! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 7/18/2012 16:27'!
tradingTickets
	"Durante esta etapa se realizan las transacciones de compra-venta del producto correspondiente al OrderBook, siempre al precio fijo establecido por el Precio de Mercado en la etapa anterior"

	| tradingTickets calculatedMarketPrice tradingPurchaseOrders tradingSalesOrders matched |
	tradingTickets := OrderedCollection new.
	calculatedMarketPrice := self marketPrice.	
	(calculatedMarketPrice isNil ) ifTrue: [^tradingTickets ].
	tradingPurchaseOrders := purchaseOrders
		asSortedCollection: [ :purchaseOrderA :purchaseOrderB | 
			purchaseOrderA unitPrice = purchaseOrderB unitPrice 
				ifTrue: [ purchaseOrderA quantity > purchaseOrderB quantity ]
				ifFalse: [ purchaseOrderA unitPrice > purchaseOrderB unitPrice ] ].
	tradingSalesOrders := salesOrders
		asSortedCollection: [ :purchaseOrderA :purchaseOrderB | 
			purchaseOrderA unitPrice = purchaseOrderB unitPrice
				ifTrue: [ purchaseOrderA quantity < purchaseOrderB quantity ]
				ifFalse: [ purchaseOrderA unitPrice < purchaseOrderB unitPrice ] ].
	
	matched := false.
	tradingPurchaseOrders
		do: [ :purchaseOrder | 
			tradingSalesOrders
				do: [ :salesOrder | 
					purchaseOrder unitPrice >= calculatedMarketPrice & (purchaseOrder quantity = salesOrder quantity)
						& (salesOrder unitPrice <= calculatedMarketPrice) & (matched = false)
						ifFalse: [  ]
						ifTrue: [ 
							tradingTickets
								add:
									(TradingTicket
										purchaseOrder: purchaseOrder
										salesOrder: salesOrder
										marketPrice: calculatedMarketPrice
										transactionDate: Date today).
							matched := true. 
							] ].
			matched := false ].
	^ tradingTickets! !

Object subclass: #PEM
	instanceVariableNames: 'tradingTickets orderBook issuers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

!PEM methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 20:59'!
addEmisor: anEmisor
	"Agrega un empleado al arreglo de empleados"

	anEmisor isNil
		ifFalse: [ issuers add: anEmisor ]! !

!PEM methodsFor: 'as yet unclassified' stamp: 'OLSA 7/17/2012 13:02'!
emisores

	| emisores |
	^ emisores! !

!PEM methodsFor: 'initialize-release' stamp: 'PauloPerez 7/16/2012 20:59'!
initialize
	tradingTickets := OrderedCollection new.
	issuers := OrderedCollection new.
	orderBook := OrderBook new! !

!PEM methodsFor: 'as yet unclassified' stamp: 'OLSA 7/17/2012 13:03'!
issuers 
	
	^ issuers ! !

!PEM methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/13/2012 18:13'!
marketPrice
"El Precio de Mercado es el precio nico por unidad al cual se comercializarn los productos en la etapa de trading"
	^ orderBook marketPrice! !

!PEM methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/16/2012 21:16'!
receiveOrder: anOrder
	"Agrega una orden al orderBook"

	anOrder isNil
		ifFalse: [ orderBook addOrder: anOrder ]! !

!PEM methodsFor: 'as yet unclassified' stamp: 'OLSA 7/17/2012 15:04'!
totalOrders
	"comment stating purpose of message"

	^orderBook totalOrders ! !

!PEM methodsFor: 'as yet unclassified' stamp: 'PauloPerez 7/13/2012 18:11'!
tradingTickets
	"Durante esta etapa se realizan las transacciones de compra-venta de productos, siempre al precio fijo establecido por el Precio de Mercado en la etapa anterior"

	^ orderBook tradingTickets! !

Object subclass: #TheoreticalTrade
	instanceVariableNames: 'units'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

!TheoreticalTrade methodsFor: 'adding' stamp: 'PauloPerez 7/18/2012 00:23'!
addUnit: unitPrice demand: amount
	| unit |
	unit := TheoreticalUnitTradeable bid: amount price: unitPrice.
	(units includes: unit)
		ifFalse: [ units add: unit ]
		ifTrue: [ (units detect: [ :unitIncluded | unitIncluded = unit ]) bid: amount ]! !

!TheoreticalTrade methodsFor: 'adding' stamp: 'PauloPerez 7/18/2012 00:22'!
addUnit: unitPrice supply: amount
	| unit |
	unit := TheoreticalUnitTradeable ask: amount price: unitPrice.
	(units includes: unit)
		ifFalse: [ units add: unit ]
		ifTrue: [ (units detect: [ :unitIncluded | unitIncluded = unit ]) ask: amount ]! !

!TheoreticalTrade methodsFor: 'initialize-release' stamp: 'PauloPerez 7/18/2012 00:30'!
initialize
	units := SortedCollection new.! !

!TheoreticalTrade methodsFor: 'evaluating' stamp: 'PauloPerez 7/18/2012 01:54'!
priceForMaximumTheoreticalAmount
	| lastUnitFromSortedUnitsByMaximumAmount |
	units reSort.
	lastUnitFromSortedUnitsByMaximumAmount := units last.
	lastUnitFromSortedUnitsByMaximumAmount maximumTheoreticalAmount = 0
		ifFalse: [ ^ lastUnitFromSortedUnitsByMaximumAmount price ]
		ifTrue: [ ^ nil ]! !

Object subclass: #TheoreticalUnitTradeable
	instanceVariableNames: 'supply demand price maximumTheoreticalAmount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

!TheoreticalUnitTradeable class methodsFor: 'class initialization' stamp: 'PauloPerez 7/17/2012 22:30'!
ask: supply price: unitPrice
	^ (self new)
		bid: 0 ask: supply price: unitPrice;
		yourself! !

!TheoreticalUnitTradeable class methodsFor: 'class initialization' stamp: 'PauloPerez 7/17/2012 22:30'!
bid: demand price: unitPrice
	^ (self new)
		bid: demand ask: 0 price: unitPrice;
		yourself! !

!TheoreticalUnitTradeable methodsFor: 'comparing' stamp: 'PauloPerez 7/18/2012 00:28'!
<= aTheoreticalUnitTradeable
	| otherMaximum |
	otherMaximum := aTheoreticalUnitTradeable maximumTheoreticalAmount.
	^ maximumTheoreticalAmount <= otherMaximum! !

!TheoreticalUnitTradeable methodsFor: 'comparing' stamp: 'PauloPerez 7/18/2012 00:06'!
= aTheoreticalUnitTradeable
	| otherPrice |
	otherPrice := aTheoreticalUnitTradeable price.
	^ price = otherPrice! !

!TheoreticalUnitTradeable methodsFor: 'accessing' stamp: 'PauloPerez 7/18/2012 00:24'!
ask: amountSupply
	supply := amountSupply.
	self computeMaximumTheoreticalAmount! !

!TheoreticalUnitTradeable methodsFor: 'accessing' stamp: 'PauloPerez 7/18/2012 00:24'!
bid: amountDemand
	demand := amountDemand.
	self computeMaximumTheoreticalAmount! !

!TheoreticalUnitTradeable methodsFor: 'accessing' stamp: 'PauloPerez 7/17/2012 22:30'!
bid: amountDemand ask: amountSupply price: unitPrice
	demand := amountDemand.
	supply := amountSupply.
	price := unitPrice.
	self computeMaximumTheoreticalAmount! !

!TheoreticalUnitTradeable methodsFor: 'private' stamp: 'PauloPerez 7/17/2012 22:30'!
computeMaximumTheoreticalAmount
	demand <= supply
		ifTrue: [ maximumTheoreticalAmount := demand ]
		ifFalse: [ maximumTheoreticalAmount := supply ]! !

!TheoreticalUnitTradeable methodsFor: 'accessing' stamp: 'PauloPerez 7/17/2012 23:04'!
maximumTheoreticalAmount
	^ maximumTheoreticalAmount! !

!TheoreticalUnitTradeable methodsFor: 'accessing' stamp: 'PauloPerez 7/17/2012 22:34'!
price
	^ price! !

Object subclass: #TradingTicket
	instanceVariableNames: 'marketPrice transactionDate purchaseOrder salesOrder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProyectoFinal'!

!TradingTicket class methodsFor: 'class initialization' stamp: 'PauloPerez 7/16/2012 21:27'!
purchaseOrder: aPurchaseOrder salesOrder: aSalesOrder marketPrice: aMarketPrice transactionDate: aTransactionDate
	^ (self new)
		purchaseOrder: aPurchaseOrder
			salesOrder: aSalesOrder
			marketPrice: aMarketPrice
			transactionDate: aTransactionDate;
		yourself! !

!TradingTicket methodsFor: 'printing' stamp: 'DiegoValdeblanquez 7/18/2012 11:39'!
printOn: aStream
	aStream
		cr;
		nextPutAll: 'Ticket ';
		cr;
		cr;
		print: purchaseOrder;
		print: salesOrder;
		space;
		cr;
		nextPutAll: 'Precio mercado ';
		print: marketPrice;
		cr;
		nextPutAll: 'Fecha transaccin ';
		print: transactionDate;
		cr;
		nextPutAll: '----------------------------------------------------------------------------------'.
	aStream cr! !

!TradingTicket methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 7/18/2012 14:49'!
purchaseOrder
	^ purchaseOrder! !

!TradingTicket methodsFor: 'accessing' stamp: 'PauloPerez 7/16/2012 21:28'!
purchaseOrder: aPurchaseOrder salesOrder: aSalesOrder marketPrice: aMarketPrice transactionDate: aTransactionDate
	"Mensaje que escribe en cada TradingTicket los datos de las ordenes de compra y venta que se puedieron efectivizar a un cierto precio de mercado calculado y definido en una fecha determinada."

	purchaseOrder := aPurchaseOrder.
	salesOrder := aSalesOrder.
	marketPrice := aMarketPrice.
	transactionDate := aTransactionDate! !
